=== modified file 'NEWS'
--- NEWS	2008-03-06 01:59:26 +0000
+++ NEWS	2008-02-29 03:46:27 +0000
@@ -1,13 +1,7 @@
 What's changed in loggerhead?
 =============================
 
-1.2.1  [06mar2008]
-------------------
-
-    - The changelog view was out of order when not using the revision
-      cache.
-
-1.2  [04mar2008]
+1.2  [29feb2008]
 ----------------
 
     - Michael Hudson <michael.hudson@canonical.com> has mostly taken

=== modified file 'README.txt'
--- README.txt	2008-03-03 23:10:35 +0000
+++ README.txt	2008-02-29 03:46:27 +0000
@@ -7,49 +7,34 @@
 navigate a branch history, annotate files, perform searches... all the
 usual things.
 
-To get started, first you need to create a 'loggerhead.conf' file
-specifying the branches you want to view.  A 'loggerhead.conf.example'
-file is included in the source which has comments explaining the
-various options.
-
-Loggerhead can then be started by running::
+This is a TurboGears (http://www.turbogears.org) project.  It can be
+started by running::
 
     $ ./start-loggerhead.py
 
-This will run loggerhead in the background.  It listens on port 8080
-by default, so go to http://localhost:8080/ in your browser to see the
-list of bublished branches.
-
-To stop Loggerhead, run::
+This will run loggerhead in the background.  To stop it, run::
 
     $ ./stop-loggerhead.py
 
-If you want to view Bazaar branches from your existing Apache
-installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to you Apache
-configuration is one way to do this::
+If you're not familiar with TurboGears, the simplest way to get running
+is to add the lines like the following to your apache configuration::
 
     <Location "/branches/">
         ProxyPass http://127.0.0.1:8080/
         ProxyPassReverse http://127.0.0.1:8080/
     </Location>
 
-In the configuration file you can configure projects, and branches per
-project.  The idea is that you could be publishing several (possibly
-unrelated) projects through the same loggerhead instance, and several
-branches for the same project.  See the "loggerhead.conf.example" file
+The config file is "loggerhead.conf".  In there, you can configure
+projects, and branches per project.  The idea is that you could be
+publishing several (possibly unrelated) projects through the same
+loggerhead instance, and several branches for the same project.  A
+commented example of a configuration file is loggerhead.conf.example
 included with the source.
 
-Although Loggerhead is a TurboGears (http://www.turbogears.org)
-project, don't bother with "dev.cfg" or any of the other TurboGears
-config files.  Loggerhead overrides those values with its own.
-
-A debug and access log are stored in the logs/ folder, relative to
-the location of the start-loggerhead.py script.
-
-You may update the Bazaar branch at any time (for example, from a cron).
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
+Don't bother with "dev.cfg" or any of the other TurboGears config files.
+Loggerhead overrides those values with its own.
+
+A debug and access log are stored in the logs/ folder.
 
 
 CACHES
@@ -62,7 +47,8 @@
     - a cache of files changed in a revision
     - a text searching cache
 
-You can put the cache folder anywhere.
+You can put the cache folder anywhere.  A folder under the branch's
+.bzr/ folder is a convenient place.
 
 The revision data cache and text searching cache will be automatically
 filled once loggerhead starts up.  The caches for a branch with 15,000
@@ -70,14 +56,13 @@
 mileage may vary.  Once they are built, they update every six hours or
 so but usually finish quickly (or instantly) after the initial creation.
 
+You may update the Bazaar branch at any time (for example, from a cron).
+Loggerhead will notice and refresh, and Bazaar uses its own branch
+locking to prevent corruption.
+
 
 SUPPORT
 -------
 
-Loggerhead is loosely based on bazaar-webserve, which was loosely
-based on hgweb.  Discussion should take place on the bazaar-dev
-mailing list at bazaar@lists.canonical.com.  You can join the list at
-<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
-subscribe to post, but your first post will be held briefly for manual
-moderation.
-
+This is loosely based on bazaar-webserve, which was loosely based on hgweb.
+Discussion should take place on the bazaar-dev mailing list.

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2008-03-06 07:30:37 +0000
+++ loggerhead.conf.example	2007-06-18 23:07:53 +0000
@@ -5,9 +5,6 @@
 # use this if you're mapping loggerhead within apache via proxy
 #server.webpath = 'http://example.com/branches'
 
-# use this if you want loggerhead to listen to another interface than 127.0.0.1
-# server.socket_host = 'your_hostname_or_ip'
-
 # where's bzrlib?
 # (you only need this if you don't install bzr.)
 #bzrpath = '/Users/robey/code/bzr/bzr'

=== modified file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2008-04-18 00:33:19 +0000
+++ loggerhead/branchview.py	2008-02-27 03:36:09 +0000
@@ -45,15 +45,13 @@
 
 
 class BranchView (object):
-    def __init__(self, group_name, name, subfolder, absfolder, config,
-                 project_config, root_config):
+    def __init__(self, group_name, name, subfolder, absfolder, config, project_config):
         self._group_name = group_name
         self._name = name
         self._folder = subfolder
         self._absfolder = absfolder
         self._config = config
         self._project_config = project_config
-        self._root_config = root_config
         self.log = logging.getLogger('loggerhead.%s' % (name,))
 
         # branch history
@@ -129,12 +127,6 @@
     def index(self):
         raise HTTPRedirect(self.url('/changes'))
 
-    def get_config_item(self, item, default=None):
-        for conf in self._config, self._project_config, self._root_config:
-            if item in conf:
-                return conf[item]
-        return default
-
     @with_history_lock
     def get_history(self):
         """

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2008-04-18 00:33:19 +0000
+++ loggerhead/controllers/__init__.py	2008-02-27 03:35:24 +0000
@@ -40,13 +40,12 @@
 
 
 class Project (object):
-    def __init__(self, name, config, root_config):
+    def __init__(self, name, config):
         self.name = name
         self.friendly_name = config.get('name', name)
         self.description = config.get('description', '')
         self.long_description = config.get('long_description', '')
         self._config = config
-        self._root_config = root_config
         
         self._views = []
         for view_name in config.sections:
@@ -84,9 +83,7 @@
         
     def _add_view(self, view_name, view_config, folder):
         c_view_name = cherrypy_friendly(view_name)
-        view = BranchView(
-            self.name, c_view_name, view_name, folder, view_config,
-            self._config, self._root_config)
+        view = BranchView(self.name, c_view_name, view_name, folder, view_config, self._config)
         self._views.append(view)
         setattr(self, c_view_name, view)
         
@@ -99,8 +96,7 @@
         self._config = config
         for project_name in self._config.sections:
             c_project_name = cherrypy_friendly(project_name)
-            project = Project(
-                c_project_name, self._config[project_name], self._config)
+            project = Project(c_project_name, self._config[project_name])
             self._projects.append(project)
             setattr(self, c_project_name, project)
         

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2008-03-10 04:02:42 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-02-27 03:35:24 +0000
@@ -46,7 +46,7 @@
             else:
                 revid = None
 
-            filter_file_id = kw.get('filter_file_id', None)
+            file_id = kw.get('file_id', None)
             query = kw.get('q', None)
             start_revid = h.fix_revid(kw.get('start_revid', None))
             orig_start_revid = start_revid
@@ -54,8 +54,7 @@
             search_failed = False
 
             try:
-                revid, start_revid, revid_list = h.get_view(
-                    revid, start_revid, filter_file_id, query)
+                revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
                 kw['start_revid'] = start_revid
                 util.set_context(kw)
 
@@ -77,10 +76,8 @@
                 self.log.exception('Exception fetching changes')
                 raise InternalError('Could not fetch changes')
 
-            navigation = util.Container(
-                pagesize=pagesize, revid=revid, start_revid=start_revid,
-                revid_list=revid_list, filter_file_id=filter_file_id,
-                scan_url='/changes', branch=self._branch, feed=True)
+            navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revid_list=revid_list,
+                                        file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)
             if query is not None:
                 navigation.query = query
             util.fill_in_navigation(navigation)
@@ -107,7 +104,7 @@
                 'history': h,
                 'revid': revid,
                 'navigation': navigation,
-                'filter_file_id': filter_file_id,
+                'file_id': file_id,
                 'start_revid': start_revid,
                 'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
                 'query': query,

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2008-03-10 04:19:01 +0000
+++ loggerhead/controllers/inventory_ui.py	2008-02-27 03:35:24 +0000
@@ -64,7 +64,6 @@
                 raise InternalError('Could not fetch changes')
 
             file_id = kw.get('file_id', inv.root.file_id)
-            start_revid = kw.get('start_revid', None)
             sort_type = kw.get('sort', None)
 
             # no navbar for revisions
@@ -100,7 +99,6 @@
                 'history': h,
                 'posixpath': posixpath,
                 'navigation': navigation,
-                'start_revid': start_revid,
             }
             h.flush_cache()
             self.log.info('/inventory %r: %r secs' % (revid, time.time() - z))

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2008-04-18 03:22:47 +0000
+++ loggerhead/controllers/revision_ui.py	2008-02-27 03:35:24 +0000
@@ -25,9 +25,6 @@
 from loggerhead import util
 
 
-DEFAULT_LINE_COUNT_LIMIT = 3000
-
-
 class RevisionUI (object):
 
     def __init__(self, branch):
@@ -50,22 +47,20 @@
             else:
                 revid = None
 
-            filter_file_id = kw.get('filter_file_id', None)
+            file_id = kw.get('file_id', None)
             start_revid = h.fix_revid(kw.get('start_revid', None))
             query = kw.get('q', None)
             remember = kw.get('remember', None)
             compare_revid = kw.get('compare_revid', None)
 
             try:
-                revid, start_revid, revid_list = h.get_view(revid, start_revid, filter_file_id, query)
+                revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
             except:
                 self.log.exception('Exception fetching changes')
                 raise InternalError('Could not fetch changes')
 
-            navigation = util.Container(
-                revid_list=revid_list, revid=revid, start_revid=start_revid,
-                filter_file_id=filter_file_id, pagesize=1,
-                scan_url='/revision', branch=self._branch, feed=True)
+            navigation = util.Container(revid_list=revid_list, revid=revid, start_revid=start_revid, file_id=file_id,
+                                        pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
             if query is not None:
                 navigation.query = query
             util.fill_in_navigation(navigation)
@@ -74,13 +69,6 @@
             # add parent & merge-point branch-nick info, in case it's useful
             h.get_branch_nicks([ change ])
 
-            line_count_limit = int(self._branch.get_config_item(
-                'line_count_limit', DEFAULT_LINE_COUNT_LIMIT))
-            line_count = 0
-            for file in change.changes.modified:
-                for chunk in file.chunks:
-                    line_count += len(chunk.diff)
-
             # let's make side-by-side diff be the default
             side_by_side = not kw.get('unified', False)
             if side_by_side:
@@ -91,7 +79,7 @@
                 'revid': revid,
                 'change': change,
                 'start_revid': start_revid,
-                'filter_file_id': filter_file_id,
+                'file_id': file_id,
                 'util': util,
                 'history': h,
                 'navigation': navigation,
@@ -99,9 +87,6 @@
                 'remember': remember,
                 'compare_revid': compare_revid,
                 'side_by_side': side_by_side,
-                'line_count': line_count,
-                'line_count_limit': line_count_limit,
-                'show_plain_diffs': line_count > line_count_limit,
             }
             h.flush_cache()
             self.log.info('/revision: %r seconds' % (time.time() - z,))

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2008-04-15 03:10:32 +0000
+++ loggerhead/daemon.py	2008-02-27 03:36:09 +0000
@@ -9,6 +9,7 @@
     background as a daemon.
     """
 
+    UMASK = 0
     WORKDIR = "/"
     REDIRECT_TO = getattr(os, 'devnull', '/dev/null')
     MAXFD = 1024
@@ -18,7 +19,7 @@
     except OSError, e:
         raise Exception("%s [%d]" % (e.strerror, e.errno))
 
-    if pid == 0:      # The first child.
+    if (pid == 0):      # The first child.
         os.setsid()
 
         try:
@@ -26,30 +27,33 @@
         except OSError, e:
             raise Exception, "%s [%d]" % (e.strerror, e.errno)
 
-        if pid == 0:  # The second child.
+        if (pid == 0):  # The second child.
             os.chdir(WORKDIR)
+            os.umask(UMASK)
         else:
             os._exit(0) # Exit parent (the first child) of the second child.
     else:
         os._exit(0)     # Exit parent of the first child.
 
-    import resource            # Resource usage information.
-    maxfd = resource.getrlimit(resource.RLIMIT_NOFILE)[1]
-    if (maxfd == resource.RLIM_INFINITY):
-        maxfd = MAXFD
-
-    fd = os.open(REDIRECT_TO, os.O_RDONLY)
-    os.dup2(fd, 0)
-    fd = os.open(REDIRECT_TO, os.O_WRONLY)
-    os.dup2(fd, 1)
-    os.dup2(fd, 2)
-
-    # Iterate through and close all other file descriptors.
-    for fd in range(3, maxfd):
-        try:
-            os.close(fd)
-        except OSError:        # ERROR, fd wasn't open to begin with (ignored)
-            pass
+    #import resource            # Resource usage information.
+    #maxfd = resource.getrlimit(resource.RLIMIT_NOFILE)[1]
+    #if (maxfd == resource.RLIM_INFINITY):
+    #    maxfd = MAXFD
+
+    # Iterate through and close all file descriptors.
+    #for fd in range(3, maxfd):
+    #    try:
+    #        os.close(fd)
+    #    except OSError:        # ERROR, fd wasn't open to begin with (ignored)
+    #        pass
+
+    # This call to open is guaranteed to return the lowest file descriptor,
+    # which will be 0 (stdin), since it was closed above.
+    #os.open(REDIRECT_TO, os.O_RDWR)    # standard input (0)
+
+    # Duplicate standard input to standard output and standard error.
+    #os.dup2(0, 1)                      # standard output (1)
+    #os.dup2(0, 2)                      # standard error (2)
 
     f = open(pidfile, 'w')
     f.write('%d\n' % (os.getpid(),))

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-06-10 03:14:05 +0000
+++ loggerhead/history.py	2008-02-27 03:36:09 +0000
@@ -202,17 +202,13 @@
         self = cls()
         self._branch = branch
         self._last_revid = self._branch.last_revision()
+        self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
 
         if name is None:
             name = self._branch.nick
         self._name = name
         self.log = logging.getLogger('loggerhead.%s' % (name,))
 
-        graph = branch.repository.get_graph()
-        parent_map = dict(((key, value) for key, value in
-             graph.iter_ancestry([self._last_revid]) if value is not None))
-
-        self._revision_graph = self._strip_NULL_ghosts(parent_map)
         self._full_history = []
         self._revision_info = {}
         self._revno_revid = {}
@@ -221,17 +217,13 @@
         else:
             self._merge_sort = bzrlib.tsort.merge_sort(
                 self._revision_graph, self._last_revid, generate_revno=True)
-
         for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
             self._full_history.append(revid)
             revno_str = '.'.join(str(n) for n in revno)
             self._revno_revid[revno_str] = revid
-            self._revision_info[revid] = (
-                seq, revid, merge_depth, revno_str, end_of_merge)
-
+            self._revision_info[revid] = (seq, revid, merge_depth, revno_str, end_of_merge)
         # cache merge info
         self._where_merged = {}
-
         for revid in self._revision_graph.keys():
             if self._revision_info[revid][2] == 0:
                 continue
@@ -241,21 +233,6 @@
         self.log.info('built revision graph cache: %r secs' % (time.time() - z,))
         return self
 
-    @staticmethod
-    def _strip_NULL_ghosts(revision_graph):
-        """
-        Copied over from bzrlib meant as a temporary workaround deprecated 
-        methods.
-        """
-
-        # Filter ghosts, and null:
-        if bzrlib.revision.NULL_REVISION in revision_graph:
-            del revision_graph[bzrlib.revision.NULL_REVISION]
-        for key, parents in revision_graph.items():
-            revision_graph[key] = tuple(parent for parent in parents if parent
-                in revision_graph)
-        return revision_graph
-
     @classmethod
     def from_folder(cls, path, name=None):
         b = bzrlib.branch.Branch.open(path)
@@ -331,28 +308,17 @@
     def get_revision_history(self):
         return self._full_history
 
-    def get_revids_from(self, revid_list, start_revid):
-        """
-        Yield the mainline (wrt start_revid) revisions that merged each
-        revid in revid_list.
-        """
-        if revid_list is None:
-            revid_list = self._full_history
-        revid_set = set(revid_list)
-        revid = start_revid
-        def introduced_revisions(revid):
-            r = set([revid])
-            seq, revid, md, revno, end_of_merge = self._revision_info[revid]
-            i = seq + 1
-            while i < len(self._merge_sort) and self._merge_sort[i][2] > md:
-                r.add(self._merge_sort[i][1])
-                i += 1
-            return r
-        while 1:
-            if bzrlib.revision.is_null(revid):
-                return
-            if introduced_revisions(revid) & revid_set:
+    def get_revids_from(self, revid_list, revid):
+        """
+        given a list of revision ids, yield revisions in graph order,
+        starting from revid.  the list can be None if you just want to travel
+        across all revisions.
+        """
+        while True:
+            if (revid_list is None) or (revid in revid_list):
                 yield revid
+            if not self._revision_graph.has_key(revid):
+                return
             parents = self._revision_graph[revid]
             if len(parents) == 0:
                 return
@@ -528,7 +494,7 @@
             if revid not in revid_list:
                 # if the given revid is not in the revlist, use a revlist that
                 # starts at the given revid.
-                revid_list = self.get_file_view(revid, file_id)
+                revid_list= self.get_file_view(revid, file_id)
                 start_revid = revid
             return revid, start_revid, revid_list
 
@@ -690,12 +656,8 @@
         revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
                             revid_list)
         repo = self._branch.repository
-        parent_map = repo.get_graph().get_parent_map(revid_list)
-        # We need to return the answer in the same order as the input,
-        # less any ghosts.
-        present_revids = [revid for revid in revid_list
-                          if revid in parent_map]
-        rev_list = repo.get_revisions(present_revids)
+        rev_list = repo.get_revisions(
+            repo.get_graph().get_parent_map(revid_list))
 
         return [self._change_from_revision(rev) for rev in rev_list]
 
@@ -839,7 +801,7 @@
                     diff = buffer.getvalue()
             else:
                 diff = ''
-            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff), raw_diff=diff))
+            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff)))
 
         return out
 
@@ -979,10 +941,14 @@
 
         file_revid = self.get_inventory(revid)[file_id].revision
         oldvalues = None
-        tree = self._branch.repository.revision_tree(file_revid)
+
+        # because we cache revision metadata ourselves, it's actually much
+        # faster to call 'annotate_iter' on the weave directly than it is to
+        # ask bzrlib to annotate for us.
+        w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
+
         revid_set = set()
-
-        for line_revid, text in tree.annotate_iter(file_id):
+        for line_revid, text in w.annotate_iter(file_revid):
             revid_set.add(line_revid)
             if self._BADCHARS_RE.match(text):
                 # bail out; this isn't displayable text
@@ -990,11 +956,10 @@
                                      text='(This is a binary file.)',
                                      change=util.Container())
                 return
-        change_cache = dict([(c.revid, c) \
-                for c in self.get_changes(list(revid_set))])
+        change_cache = dict([(c.revid, c) for c in self.get_changes(list(revid_set))])
 
         last_line_revid = None
-        for line_revid, text in tree.annotate_iter(file_id):
+        for line_revid, text in w.annotate_iter(file_revid):
             if line_revid == last_line_revid:
                 # remember which lines have a new revno and which don't
                 status = 'same'

=== modified file 'loggerhead/release.py'
--- loggerhead/release.py	2008-03-06 01:59:26 +0000
+++ loggerhead/release.py	2008-02-28 04:45:06 +0000
@@ -1,6 +1,6 @@
 # Release information about loggerhead
 
-version = "1.2.1"
+version = "1.2"
 
 description = "Loggerhead is a web viewer for projects in bazaar."
 

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2008-04-18 00:00:58 +0000
+++ loggerhead/static/css/style.css	2007-09-04 01:47:51 +0000
@@ -450,12 +450,6 @@
     background-color: #dee7ec;
 }*/
 
-pre.diff-plain {
-    border: 1px solid #8cacbb;
-    background-color: #f4f5f8;
-    padding: 1em;
-    font-size: smaller;
-}
 
 /* ----- file inventory ----- */
 

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2008-03-30 23:24:49 +0000
+++ loggerhead/templates/annotate.kid	2007-09-04 17:06:03 +0000
@@ -14,7 +14,7 @@
 	<div class="links">
 	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context(clear=1))}"> browse files </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}"> view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, filter_file_id=file_id))}"> view changes to this file </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, file_id=file_id))}"> view changes to this file </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> download file </a> </div>
 	</div>
 </h1>
@@ -30,8 +30,8 @@
         <tr py:for="line in contents" class="parity${line.parity}">
             <td class="lineno ${line.status}"><a name="L${line.lineno}"> ${line.lineno} </a></td>
             <td class="revno ${line.status}">
-                <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, filter_file_id=file_id))}"
-                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, ${util.date_time(line.change.date)}})">${util.trunc(line.change.revno)}</a>
+                <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id))}"
+                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${util.format_date(line.change.date)} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
             </td>
             <td class="text ${line.status}"> ${line.text} </td>
         </tr>

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2008-03-09 00:22:47 +0000
+++ loggerhead/templates/browse.kid	2008-02-27 01:55:39 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${view.get_history().has_revisions and util.approximatedate(view.last_updated()) or "(no revisions)"} </td>
+            <td class="last-update"> ${view.get_history().has_revisions and util.ago(view.last_updated()) or "(no revisions)"} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2008-03-10 04:22:42 +0000
+++ loggerhead/templates/changelog.kid	2007-09-04 17:21:59 +0000
@@ -37,7 +37,7 @@
 ${navbar()}
 
 <h1> <span class="branch-name">${branch.friendly_name}</span> : changes
-<span py:if="filter_file_id"> to <span class="filename">${history.get_path(revid, filter_file_id)}</span></span>
+<span py:if="file_id"> to <span class="filename">${history.get_path(revid, file_id)}</span></span>
 <span py:if="viewing_from"> from ${history.get_revno(start_revid)} </span>
 <span py:if="query"> matching "${query}"</span>
 </h1>
@@ -77,7 +77,7 @@
             <span py:strip="True" py:if="not all_same_author">
                 <td class="author"> ${util.trunc(util.hide_email(entry.author), 20)} </td>
             </span>
-            <td class="date"> ${util.approximatedate(entry.date)} </td>
+            <td class="date"> ${util.format_date(entry.date)} &nbsp; (${util.ago(entry.date)}) </td>
             <td class="inventory-link"> 
                 <a href="${branch.url([ '/files', entry.revid ])}"
                     title="Files at revision ${entry.revno}"> files</a>

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2008-03-10 04:22:42 +0000
+++ loggerhead/templates/inventory.kid	2007-09-04 17:06:03 +0000
@@ -28,7 +28,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.date_time(change.date)} </td>
+            <td class="date"> ${util.format_date(change.date)} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -85,12 +85,12 @@
             <a py:if="file.kind=='file'" href="${branch.context_url([ '/annotate', revid ],
                 file_id=file.file_id)}" title="Annotate ${file.filename}">${file.filename}</a>
         </td>
-        <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, filter_file_id=file.file_id))} </td>
-        <td class="date"> ${util.date_time(file.change.date)} </td>
+        <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, file_id=file.file_id))} </td>
+        <td class="date"> ${util.format_date(file.change.date)} </td>
         <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
         <td class="changes-link"> 
-            <a href="${branch.context_url('/changes', start_revid=start_revid, file_id=file.file_id)}"
-               title="Changes affecting ${file.filename}"> changes </a>
+            <a href="${branch.context_url('/changes', start_revid=file.revid, file_id=file.file_id)}"
+               title="Changes affecting ${file.filename} up to revision ${file.change.revno}"> changes </a>
         </td>
         <td class="download-link">
             <a href="${branch.url([ '/download', file.revid, file.file_id, file.filename ])}"

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2008-03-07 10:16:51 +0000
+++ loggerhead/templates/master.kid	2007-09-02 22:54:43 +0000
@@ -1,106 +1,106 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<?python import sitetemplate ?>
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#" py:extends="sitetemplate">
-
-<head py:match="item.tag=='{http://www.w3.org/1999/xhtml}head'" py:attrs="item.items()">
-    <meta content="text/html; charset=UTF-8" http-equiv="content-type" py:replace="''"/>
-    <title py:replace="''">Your title goes here</title>
-    <meta py:replace="item[:]"/>
-    <style type="text/css" media="screen">
-@import "${tg.url('/static/css/style.css')}";
-    </style>
-
-<!-- !define common navbar -->
-<span py:def="navbar()" py:strip="True">
-    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
-    <div class="bar" py:if="navigation is not None">
-        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<?python import sitetemplate ?>
+<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#" py:extends="sitetemplate">
+
+<head py:match="item.tag=='{http://www.w3.org/1999/xhtml}head'" py:attrs="item.items()">
+    <meta content="text/html; charset=UTF-8" http-equiv="content-type" py:replace="''"/>
+    <title py:replace="''">Your title goes here</title>
+    <meta py:replace="item[:]"/>
+    <style type="text/css" media="screen">
+@import "${tg.url('/static/css/style.css')}";
+    </style>
+
+<!-- !define common navbar -->
+<span py:def="navbar()" py:strip="True">
+    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
+    <div class="bar" py:if="navigation is not None">
+        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
         <form action="${branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None),
-              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
-            <td><span class="buttons">
-                <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                <a href="${branch.context_url('/changes', clear=1)}"> changes </a>
-                <a href="${branch.context_url('/files', clear=1)}"> files </a>
-                <span class="search"> search: <input type="text" name="q" /> </span>
+              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
+            <td><span class="buttons">
+                <!-- ! navbar buttons never change, from now on.  i decree it! -->
+                <a href="${branch.context_url('/changes', clear=1)}"> changes </a>
+                <a href="${branch.context_url('/files', clear=1)}"> files </a>
+                <span class="search"> search: <input type="text" name="q" /> </span>
             </span></td>
-            <td align="right" py:if="hasattr(navigation, 'revid_list')">
-                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
+            <td align="right" py:if="hasattr(navigation, 'revid_list')">
+                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
                     <a href="${branch.url('/atom')}">
-                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
-                </span>
-                <span class="navbuttons">
+                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
+                </span>
+                <span class="navbuttons">
                 	<span py:if="navigation.prev_page_revid">
                 	<a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>
-                    </span>
-                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
+                    </span>
+                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
                     revision ${history.get_revno(revid)}
-                    (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
+                    (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
                 	<span py:if="navigation.next_page_revid">
                     <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
-                    </span>
-                	<span py:if="not navigation.next_page_revid"> &#187; </span>
-                </span>
+                    </span>
+                	<span py:if="not navigation.next_page_revid"> &#187; </span>
+                </span>
             </td>
-        </tr></table></form>
-    </div>
-</span>
-
+        </tr></table></form>
+    </div>
+</span>
+
 <span py:def="revision_link(revid, text, **overrides)" py:strip="True">
     <a title="Show revision ${history.get_revno(revid)}"
        href="${branch.url([ '/revision', revid ], **util.get_context(**overrides))}"> ${text} </a>
 </span>
 
-
-<!-- ! expand button functions: -->
-
-	<span py:strip="True" py:def="use_collapse_buttons()">
-		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
-		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
-	</span>
-	
-	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
+
+<!-- ! expand button functions: -->
+
+	<span py:strip="True" py:def="use_collapse_buttons()">
+		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
+		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
+	</span>
+	
+	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
 	    <a class="hide-all collapse-${group}-hideall"
-	       href="javascript:collapseAllDisplay('${group}','none')">
+	       href="javascript:collapseAllDisplay('${group}','none')">
 	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
 	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />collapse all</a>
+	             class="collapse-triangle" />collapse all</a>
 	    <a class="hide-all collapse-${group}-showall"
-	       href="javascript:collapseAllDisplay('${group}','${normal}')">
+	       href="javascript:collapseAllDisplay('${group}','${normal}')">
 	        <img src="${tg.url('/static/images/nav-small-right.gif')}"
 	             width="10" height="10" alt="expand"
-	             class="collapse-triangle" />expand all</a>
-	</span>
-	
-	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
+	             class="collapse-triangle" />expand all</a>
+	</span>
+	
+	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
 	    <a href="javascript:collapseDisplay('${group}','${name}','none')"
-	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
+	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
 	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
 	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />
-	    </a>
+	             class="collapse-triangle" />
+	    </a>
 	    <a href="javascript:collapseDisplay('${group}','${name}','${normal}')"
-	       class="show-button collapse-${group}-${name}-show" title="expand">
+	       class="show-button collapse-${group}-${name}-show" title="expand">
 	    	<img src="${tg.url('/static/images/nav-small-right.gif')}"
 	    	     witdh="10" height="10" alt="expand"
-	    	     class="collapse-triangle" />
-	    </a>
-	</span>
-
-</head>
-
+	    	     class="collapse-triangle" />
+	    </a>
+	</span>
+
+</head>
+
 <body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'"
-      py:attrs="item.items()">
-
-    <div py:replace="[item.text]+item[:]"/>
-
-	<!-- End of main_content -->
-	
-	<div class="footer">
+      py:attrs="item.items()">
+
+    <div py:replace="[item.text]+item[:]"/>
+
+	<!-- End of main_content -->
+	
+	<div class="footer">
 	    <span class="banner"><a href="http://www.bazaar-vcs.org/">
-	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
+	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
 	    <span class="banner"><a href="http://www.lag.net/loggerhead/">
-	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
-	</div>
-</body>
-
-</html>
+	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
+	</div>
+</body>
+
+</html>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2008-04-18 00:00:58 +0000
+++ loggerhead/templates/revision.kid	2007-09-04 17:06:03 +0000
@@ -84,7 +84,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.date_time(change.date)} </td>
+            <td class="date"> ${util.format_date(change.date)} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -130,36 +130,17 @@
         <tr py:if="change.changes.modified">
             <th class="files"> files modified: </th>
             <td class="files">
-              <span py:if="not show_plain_diffs" py:strip="True">
                 <span py:for="item in change.changes.modified" class="collapse-style-sbs-content">
                     <a href="#${item.filename}-s" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
                 </span>
                 <span py:for="item in change.changes.modified" class="collapse-style-unified-content">
                     <a href="#${item.filename}-u" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
                 </span>
-              </span>
-              <span py:if="show_plain_diffs" py:strip="True">
-                <span py:for="item in change.changes.modified" py:strip="True">
-                    <a href="#${item.filename}" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
-                </span>
-              </span>
             </td>
         </tr>
     </table>
 </div>
 
-<div py:if="show_plain_diffs" py:strip="True">
-  Diff of ${line_count} lines is too long to display richly -- limit is ${line_count_limit} lines.
-
-  <pre class="diff-plain">
-    <span py:strip="True" py:for="item in change.changes.modified">
-      <a name="${item.filename}" />${item.raw_diff}
-    </span>
-  </pre>
-</div>
-
-<div py:if="change.changes.modified and not show_plain_diffs" py:strip="True">
-
 <table class="diff-option-buttons">
 <tr>
     <td> ${collapse_all_button('file', 'table-row')} </td>
@@ -181,7 +162,7 @@
 <!-- ! i'm not a big fan of embedding python code here, but the alternatives all seem to be worse -->
 <?python uniqs={}; ?>
 
-<div class="diff">
+<div class="diff" py:if="change.changes.modified">
     <!-- ! side-by-side diff -->
     <table class="diff-block collapse-style-sbs-content">
         <span py:strip="True" py:for="item in change.changes.modified">
@@ -256,7 +237,6 @@
 	</tr>
     </table>
 </div>
-</div>
 
 </body>
 </html>

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2008-04-18 03:22:47 +0000
+++ loggerhead/tests/test_corners.py	2007-09-10 13:43:45 +0000
@@ -1,4 +1,3 @@
-import re
 import os
 
 import cherrypy
@@ -94,25 +93,3 @@
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
         assert 'myfilename' in cherrypy.response.body[0]
-
-    def test_revision_size_limit(self):
-        self.createBranch()
-        msg = 'a very exciting commit message'
-        self.addFileAndCommit('myfilename', msg)
-
-        file_in_branch = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
-        file_in_branch.write('\n'.join(['line']*100))
-        file_in_branch.close()
-        newrevid = self.tree.commit(message='touch 100 lines')
-
-        self.setUpLoggerhead()
-        cherrypy.root._config['line_count_limit'] = 50
-        testutil.create_request('/project/branch/revision/'+newrevid)
-
-        match = re.search(
-            'Diff of [0-9]+ lines is too long to display richly -- limit '
-            'is 50 lines\\.',
-            cherrypy.response.body[0]
-            )
-
-        assert match is not None

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-03-10 04:22:42 +0000
+++ loggerhead/util.py	2008-02-27 03:36:09 +0000
@@ -17,8 +17,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-from elementtree import ElementTree as ET
-
 import base64
 import cgi
 import datetime
@@ -34,80 +32,67 @@
 
 log = logging.getLogger("loggerhead.controllers")
 
-# Display of times.
-
-# date_day -- just the day
-# date_time -- full date with time
-#
-# displaydate -- for use in sentences
-# approximatedate -- for use in tables
-#
-# displaydate and approximatedate return an elementtree <span> Element
-# with the full date in a tooltip.
-
-def date_day(value):
-    return value.strftime('%Y-%m-%d')
-
-
-def date_time(value):
-    return value.strftime('%Y-%m-%d %T')
-
-
-def _displaydate(date):
-    delta = abs(datetime.datetime.now() - date)
-    if delta > datetime.timedelta(1, 0, 0):
-        # far in the past or future, display the date
-        return 'on ' + date_day(date)
-    return _approximatedate(date)
-
-
-def _approximatedate(date):
+
+def timespan(delta):
+    if delta.days > 730:
+        # good grief!
+        return '%d years' % (int(delta.days // 365.25),)
+    if delta.days >= 3:
+        return '%d days' % delta.days
+    seg = []
+    if delta.days > 0:
+        if delta.days == 1:
+            seg.append('1 day')
+        else:
+            seg.append('%d days' % delta.days)
+    hrs = delta.seconds // 3600
+    mins = (delta.seconds % 3600) // 60
+    if hrs > 0:
+        if hrs == 1:
+            seg.append('1 hour')
+        else:
+            seg.append('%d hours' % hrs)
+    if delta.days == 0:
+        if mins > 0:
+            if mins == 1:
+                seg.append('1 minute')
+            else:
+                seg.append('%d minutes' % mins)
+        elif hrs == 0:
+            seg.append('less than a minute')
+    return ', '.join(seg)
+
+
+def ago(timestamp):
+    now = datetime.datetime.now()
+    return timespan(now - timestamp) + ' ago'
+
+
+def fix_year(year):
+    if year < 70:
+        year += 2000
+    if year < 100:
+        year += 1900
+    return year
+
+
+_g_format = '%Y-%m-%d @ %H:%M'
+
+def format_date(date):
+    if _g_format == 'fancy':
+        return fancy_format_date(date)
+    return date.strftime(_g_format)
+
+def fancy_format_date(date):
     delta = datetime.datetime.now() - date
-    if abs(delta) > datetime.timedelta(1, 0, 0):
-        # far in the past or future, display the date
-        return date_day(date)
-    future = delta < datetime.timedelta(0, 0, 0)
-    delta = abs(delta)
-    days = delta.days
-    hours = delta.seconds / 3600
-    minutes = (delta.seconds - (3600*hours)) / 60
-    seconds = delta.seconds % 60
-    result = ''
-    if future:
-        result += 'in '
-    if days != 0:
-        amount = days
-        unit = 'day'
-    elif hours != 0:
-        amount = hours
-        unit = 'hour'
-    elif minutes != 0:
-        amount = minutes
-        unit = 'minute'
+    if delta.days > 300:
+        return date.strftime('%d %b %Y')
     else:
-        amount = seconds
-        unit = 'second'
-    if amount != 1:
-        unit += 's'
-    result += '%s %s' % (amount, unit)
-    if not future:
-        result += ' ago'
-        return result
-
-
-def _wrap_with_date_time_title(date, formatted_date):
-    elem = ET.Element("span")
-    elem.text = formatted_date
-    elem.set("title", date_time(date))
-    return elem
-
-
-def approximatedate(date):
-    return _wrap_with_date_time_title(date, _approximatedate(date))
-
-
-def displaydate(date):
-    return _wrap_with_date_time_title(date, _displaydate(date))
+        return date.strftime('%d %b %H:%M')
+
+def set_date_format(format):
+    global _g_format
+    _g_format = format
 
 
 class Container (object):
@@ -346,7 +331,7 @@
     navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
     navigation.next_page_revid = get_offset(1 * navigation.pagesize)
 
-    params = { 'filter_file_id': navigation.filter_file_id }
+    params = { 'file_id': navigation.file_id }
     if getattr(navigation, 'query', None) is not None:
         params['q'] = navigation.query
     else:
@@ -434,11 +419,9 @@
 #         current location along the navigation path (while browsing)
 #     - starting revid (start_revid)
 #         the current beginning of navigation (navigation continues back to
-#         the original revision) -- this defines an 'alternate mainline'
-#         when the user navigates into a branch.
+#         the original revision) -- this may not be along the primary revision
+#         path since the user may have navigated into a branch
 #     - file_id
-#         the file being looked at
-#     - filter_file_id
 #         if navigating the revisions that touched a file
 #     - q (query)
 #         if navigating the revisions that matched a search query
@@ -455,8 +438,7 @@
 #         for re-ordering an existing page by different sort
 
 t_context = threading.local()
-_valid = ('start_revid', 'file_id', 'filter_file_id', 'q', 'remember',
-          'compare_revid', 'sort')
+_valid = ('start_revid', 'file_id', 'q', 'remember', 'compare_revid', 'sort')
 
 
 def set_context(map):

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2008-03-08 22:55:27 +0000
+++ start-loggerhead.py	2007-09-04 17:06:03 +0000
@@ -12,7 +12,7 @@
 import cherrypy
 cherrypy.lowercase_api = True
 
-from loggerhead import daemon, release
+from loggerhead import daemon, release, util
 
 
 def make_handler(config, filename):
@@ -86,7 +86,7 @@
     
     turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
     
-    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int), ('server.socket_host' ,str) ]
+    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
     for key, keytype in potential_overrides:
         value = config.get(key, None)
         if value is not None:
@@ -114,6 +114,7 @@
     index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
     turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
 
+    util.set_date_format(config.get('date_format', 'fancy'))
     try:
         turbogears.start_server(Root)
     finally:

